Summary: Library Optimizer Tool 
Name: TI_Linux-target-libopt
Version: 0.1
Vendor: Texas Instruments
Release: TI%{TI_release_version}
Copyright: GPL
Source0: libopt-%{version}.orig.tar.gz
Group: tools

%define pkgname ti_linux-%{_hhl_target_arch}-libopt
Buildroot:  %{TI_build_home}/%{TI_linux_home}/
%define targetroot %{TI_build_home}/%{TI_linux_home}
Prefix: %{targetroot}

%define _uclibc_bin %{TI_uclibc_base}/bin

%description
Library Optimizer Tool

%package -n %{pkgname}
Summary: Library Optimizer Tool
Group: System Environment/Daemons
AutoReqProv: no
%description -n %{pkgname}
Library Optimizer Tool

%prep
%target_check
%setup -q -n libopt-%{version}

%build

%install

# Install the Library Optimizer Tool
install -m 0755 mipsel-uclibc-libindex %{_uclibc_bin}
install -m 0755 mipsel-uclibc-libopt %{_uclibc_bin}

# Install the base configuration
cp -a optinfo %{TI_tools_path}

##################################################
# Generate the libuClibc configuration/build files
##################################################

# Get all the objects that make up the library so that we can
# rebuild it from scratch
cd %{_builddir}/uClibc-0.9.19/libc
find . -name *.o | xargs -i cp '{}' %{TI_tools_path}/optinfo/libc

# Separate the required objects from the optional objects so that
# it is easier to generate the index file used by the tools
cd %{TI_tools_path}/optinfo/libc
mv interp.o req

# Generate the index file
# Note: Use the original, unoptimized library for this step
export PATH=%{TI_uclibc_path}:$PATH
#mipsel-uclibc-libindex %{TI_filesystem_path}/lib/libuClibc-0.9.19.so -r req/*.o -o *.o > index
mipsel-uclibc-libindex %{_builddir}/uClibc-0.9.19/libc/libuClibc-0.9.19.so -r req/*.o -o *.o > index

# When to run the optimizer itself?

%clean
rm -rf *

%files 
%defattr(-,root,root)

%changelog
* Tue Jul 01 2003 (Jeff Angielski <jeff@theptrgroup.com>)
- Initial packaging of Library Optimizer Tool


