%define FILENAME        TI_Avalanche-mips_fp_le
Version: 2.4.17
Summary: Linux Support Package for the Avalanche ASIC 
Name: TI_Linux-target-kernel-linux
Release: TI%{TI_release_version}
Vendor: Texas Instruments
License: GPL
Group: LSP

Source0: linux-%{version}_mvl21_mips_malta.orig.tar.gz

#
# TI Patch dates
#
%define TI_patch_date 01_30_04 
Patch0: linux-%{version}_mvl21-%{TI_patch_date}.diff.gz

#
# PSP/NSP release version
#
%define TI_NSP_PSP_RELEASE 3.2.0

#
# SAR driver release #
#
%define TI_SAR_RELEASE 3.1.04

#
# Sangam CPMAC driver release 
#
%define TI_CPMAC_RELEASE 4.0.0

#
# Avalanche DSL driver 
#
%define TI_DSL_RELEASE 04.00.01.00

#
# Avalanche SAR PDSP Firmware 
#
%define TI_SAR_PDSP_FW 0.69D

#
# Avalanche/Raptor Modem firmware
#
%define TI_DSL_MODEM_FW 01.00.02.00

#
# Avalanche Marvell driver
#
%define TI_MARVELL_RELEASE 3.0.0


%define pkgname  ti_linux-target-linux-kernel
Buildroot:  %{TI_build_home}/%{TI_linux_home}/
%define targetroot %{TI_build_home}/%{TI_linux_home}
Prefix: %{targetroot}
BuildArch: noarch

#Source0: mips-malta-%{KERNEL_VERSION}.tgz
#Source1: hhl-%{FILENAME}.config
#Source2: hhl-%{FILENAME}-README
#Source3: hhl-%{FILENAME}-desc
#Source4: hhl_LSPs.2.0
#Patch0:  %{FILENAME}-0-%{TI_PATCH_DATE_0}.diff.gz


%description 
This package contains the kernel source code and documentation for the
Avalanche Platform Support Package [release:%{TI_NSP_PSP_RELEASE}]
*-----------Version-------------------
|SAR driver release:  %{TI_SAR_RELEASE}
|SAR PDSP firmware :  %{TI_SAR_PDSP_FW}
|DSL driver release:  %{TI_DSL_RELEASE}
|DSL Modem firmware:  %{TI_DSL_MODEM_FW}
|VMAC driver release: %{TI_VMAC_RELEASE}
|MARVELL driver release: %{TI_MARVELL_RELEASE}
*------------------------------------

# Binary package
%package -n %{pkgname}
Summary: Linux Support Package for the Avalanche PSP
Group: LSP
AutoReqProv: no
%description -n %{pkgname}
This package contains the source and documentation for the
Avalanche Platform Support Package  [release: %{TI_NSP_PSP_RELEASE}]
*------------Version-----------------
|SAR driver release:  %{TI_SAR_RELEASE}
|SAR PDSP firmware :  %{TI_SAR_PDSP_FW}
|DSL driver release:  %{TI_DSL_RELEASE}
|DSL Modem firmware:  %{TI_DSL_MODEM_FW}
|VMAC driver release: %{TI_VMAC_RELEASE}
|CPMAC driver release: %{TI_CPMAC_RELEASE}
|MARVELL driver release: %{TI_MARVELL_RELEASE}
|USB RNDIS driver:    %{TI_USB_RNDIS}
*------------------------------------

%prep
%target_check
%setup -q -n linux-%{version}_mvl21
%patch -p1

%build


%install
%host_setup
install -d %{TI_kernel_path}
cd ..
cp -a linux-%{version}_mvl21 %{TI_kernel_path}/. 


%clean
rm -rf *

%files 
#%defattr(-,root,root)
#%dir /kernel/linux-%{version}_mvl21
#/kernel/linux-%{version}_mvl21/*

#
#  CHANGELOG
#
%changelog
* Sat Nov 03 2003 (Snehaprabha N <nsnehaprabha@telogy.com>)
- Fixes to priowrr, modifications to netfilter and u32 classifiers for 
- source address (Ramesh) and modifications to generic scheduler (Ramesh).
* Sat Nov 01 2003 (Jeff Harrell <jharrell@ti.com>)
- fixed iptables Multi IP match code in Netfilter
* Fri Oct 31 2003 (Mike Hassler <mhassler@ti.com>)
- oct 31/03 ADSL2 dsl driver update, cleaned up defconfigs, mip stuff
* Thu Oct 30 2003 (Mike Hassler <mhassler@ti.com>)
- BasePSP_34_GA selective merge
* Mon Oct 27 2003 (Mike Hassler <mhassler@ti.com>)
- various NSP3.4 updates, support for AR7RD using Marvell switch
* Mon Oct 13 2003 (Snehaprabha N <nsnehaprabha@telogy.com>)
- Added new scheduler - priowrr.
* Mon Oct 06 2003 (Mike Hassler <mhassler@ti.com>)
- modifications for NSP3.4 (default 7zip kernel compression)
* Mon Sep 21 2003 (Snehaprabha N <nsnehaprabha@telogy.com>)
- Rearranged env+config space to allow more config space.
* Mon Sep 09 2003 (Snehaprabha N <nsnehaprabha@telogy.com>)
- Added changes from Jeff Angielski for kernel compression;
- changed level from 3 to 9, thus gaining a flash block.
* Mon Sep 03 2003 (Snehaprabha N <nsnehaprabha@telogy.com>)
- Added changes from Jeff Angielski for merging config.xml and env blocks.
* Mon Jul 28 2003 (Snehaprabha N <nsnehaprabha@telogy.com>)
- added configuratuon file for /var/html nfs partition.
* Mon Jul 21 2003 (Mike Hassler <mhassler@ti.com>)
- added squashfs_REL config files, regained Adam2 124K savings in kernel runtime
* Fri Jul 18 2003 (Mike Hassler <mhassler@ti.com>)
- DSL driver ATM tx fix, fix for panic on reboot w/ no DSL line, added netfilter stuff
* Sun Jul 09 2003 (Mike Hassler <mhassler@ti.com>)
- eng'g drop of DSL driver to fix LED/In/Out Sync
* Wed Jul 09 2003 (Mike Hassler <mhassler@ti.com>)
- updated DSL driver, remove 128K runtime in kernel for Adam2
* Mon Jun 23 2003 (Mike Hassler <mhassler@ti.com>)
- updated kernel w/ (br_if.c, br_stp_if.c, ipt_iprange.h, ipt_iprange.c)
* Tue Jun 17 2003 (Mike Hassler <mhassler@ti.com>)
- merge of basePSP_4.0
* Tue May 20 2003 (Snehaprabha N <nsnehaprabhars@telogy.com>)
- Modified default configuration files for AR7 boards. (MOD_VERSION)
- Merged latest DSL driver. 
* Fri May 16 2003 (Snehaprabha N <nsnehaprabhars@telogy.com>)
- Merge latest kernel code from the best&final release Linux NSP 3.1
- Also modified CPMAC no of RX/TX BDs to 128 from 256 (for 2/8 memory footprint).
* Tue May 13 2003 (Snehaprabha N <nsnehaprabhars@telogy.com>)
- Merge latest kernel code from the release label BasePSP_4.0L_BFT2_ver4.0.0.11
- for linux psp - sangam.
* Tue May 06 2003 (Snehaprabha N <nsnehaprabhars@telogy.com>)
- Merge latest kernel code from linuxdist31 kernel rpm.
* Mon Apr 28 2003 (Snehaprabha N <nsnehaprabhars@telogy.com>)
- Bug fixes.
* Fri Apr 25 2003 (Snehaprabha N <nsnehaprabhars@telogy.com>)
- Merged DSL driver for Sangam from Dallas.
* Mon Apr 22 2003 (Snehaprabha N <nsnehaprabhars@telogy.com>)
- Merged non sangam related stuff from the base 3.0.3 psp release.
- Re-organized usb slave driver depending on hardware and platform.
- Added High Resolution Timer support.
- Added PPPOE and BRCTL fixes from 3.1.0 kernel.
- Applied BR2684 patches.
- Modified ATM/DSL drivers according to 3.1.0 kernel.
- NSP related all the patches.
* Mon Feb 10 2003 (sharath kumar <krs@ti.com>)
- for rel 4.0.0
* Wed Oct 23 2002 (Marian Stagarescu <marian@ti.com>)
- best and final for rel 3.0.0.
* Wed Oct 10 2002 (Victor Wells <vwells@ti.com>)
- update to MR6 
* Tue Sep 17 2002 (Jeff Harrell <jharrell@ti.com>)
- added Broadband I/F reset to IOCTL
* Tue Sep 17 2002 (Jeff Harrell <jharrell@ti.com>)
- added IOCTL to SAR driver for soft reboot
* Thu Sep 05 2002 (Jeff Harrell <jharrell@ti.com>)
- added configuration for PSP and jffs2 for ACPEP/AR5D01
* Fri Aug 30 2002 (Marian Stagarescu <m-stagarescu@ti.com>)
- added module support for usb
* Thu Aug 22 2002 (Marian Stagarescu <m-stagarescu@ti.com>)
- BOARD=AR5D01 defconfig supports CRAMFS and removes JFFS2 
* Sun Aug 18 2002 (Marian Stagarescu <m-stagarescu@ti.com>)
- updated PDSP, DSL driver and DSL_FW versions;
* Thu Jul 17 2002 (Jeff Harrell <jharrell@ti.com>)
- Packaged Avalanche kernel source
